FUNCTION define_L1TBG1,PARASOL=parasol

; D.Afinition des parametres non directionnels
Nu_par = 3  ;  Nombre
U_par = replicate({parametre},Nu_par) ; Definition of Un directional products
U_par[0] = {parametre,'Altitude'   ,-2,10,'meters',1.  ,0.,  0,0,0}
IF parasol THEN U_par[1] = {parametre,'Solar Azim.', 1,46,'deg.'  ,1.42,0.,  0,0,0} $
           ELSE U_par[1] = {parametre,'Solar Azim.', 1,42,'deg.'  ,1.42,0.,  0,0,0}
IF parasol THEN U_par[2] = {parametre,'Numb Direc.', 1,47,'deg.'  ,1.  ,0.,  0,0,0} $
           ELSE U_par[2] = {parametre,'Numb Direc.', 1,43,'deg.'  ,1.  ,0.,  0,0,0}
;--------------------------------------------------------------------------------
; Dfinition des parametres directionnels
Nd_par = 0   ;  Number of directional products
D_par = replicate({parametre},100) ; Definition of directional products
D_par[Nd_par] = {parametre,'Ref_443'   ,-2,15,   '%',0.01,0.,  0,0,0} & Nd_par=Nd_par+1 & IF parasol THEN D_par[Nd_par-1].name='Ref_490'
D_par[Nd_par] = {parametre,'Ref_565'   ,-2,19,   '%',0.01,0.,  0,0,0} & Nd_par=Nd_par+1
D_par[Nd_par] = {parametre,'Ref_670'   ,-2,21,   '%',0.01,0.,  0,0,0} & Nd_par=Nd_par+1
D_par[Nd_par] = {parametre,'Ref_865'   ,-2,27,   '%',0.01,0.,  0,0,0} & Nd_par=Nd_par+1
D_par[Nd_par] = {parametre,'RefPol_443',-2,31,   '%',0.01,0.,  0,0,0} & Nd_par=Nd_par+1 & IF parasol THEN D_par[Nd_par-1].name='RefPol_490'
D_par[Nd_par] = {parametre,'RefPol_670',-2,33,   '%',0.01,0.,  0,0,0} & Nd_par=Nd_par+1
D_par[Nd_par] = {parametre,'RefPol_865',-2,35,   '%',0.01,0.,  0,0,0} & Nd_par=Nd_par+1
D_par[Nd_par] = {parametre,'DirPol_443',-2,31,'deg.',0.01,0.,  0,0,0} & Nd_par=Nd_par+1 & IF parasol THEN D_par[Nd_par-1].name='DirPol_490'
D_par[Nd_par] = {parametre,'DirPol_670',-2,33,'deg.',0.01,0.,  0,0,0} & Nd_par=Nd_par+1
D_par[Nd_par] = {parametre,'DirPol_865',-2,35,'deg.',0.01,0.,  0,0,0} & Nd_par=Nd_par+1

D_par = D_par[0:Nd_par-1]
;--------------------------------------------------------------------------------
; Dfinition des combinaisons non-directionnels
Nc_par = 0    ;  Number of Multi-parameter non directional
C_par = replicate({combi},Nc_par>1)
;--------------------------------------------------------------------------------
; Dfinition des combinaisons "directionnel"
Ncd_par = 4    ;  Number of Multi-parameter non directional
Cd_par = replicate({combi},Ncd_par) ; Definition of directional products
Cd_par[0] = {combi,'CompColor VIS'  ,2,1,0}
Cd_par[1] = {combi,'CompColor 3CHAN',3,2,0}
Cd_par[2] = {combi,'CompColor Polar',Nd_par-4,Nd_par-5,Nd_par-6}
Cd_par[3] = {combi,'Comp DirPol'    ,Nd_par-1,Nd_par-2,Nd_par-3}
;
IF parasol THEN $
  product={type:'L1TBG1',resol:18,Nbyte_tot:738,Nbyte_nd:50,Nbyte_d:43,Nu_par:Nu_par,U_par:U_par,Nd_par:Nd_par,D_par:D_par,$
         Nc_par:Nc_par,C_par:C_par,Ncd_par:Ncd_par,Cd_par:Cd_par} $
ELSE $
  product={type:'L1TBG1',resol:18,Nbyte_tot:648,Nbyte_nd:46,Nbyte_d:43,Nu_par:Nu_par,U_par:U_par,Nd_par:Nd_par,D_par:D_par,$
         Nc_par:Nc_par,C_par:C_par,Ncd_par:Ncd_par,Cd_par:Cd_par}
RETURN,product
END
